#! /usr/bin/perl

#this reorganises the html to remove the frames layout

use strict;
use warnings;
use HTML::Entities;

use XML::Twig;
my $t= XML::Twig->new(twig_roots => { title => 1, span => 1 });
$t->parsefile('Notes/Notes2.xhtml');
$t->set_pretty_print ('indented');
my $root= $t->root;
my $title= $root->first_child( 'title'); # get the title
my $body= $root->first_child( 'body'); # get the title
# $body->set_tag( 'div');
# $body->set_att( 'id','left');
# my $menu=encode_entities($body->sprint,'^\n\x20-\x25\x27-\x7e');
# $menu=~ s/&amp;lt/&lt/g;
# $menu=~ s/&amp;gt/&gt/g;
# $menu=~ s/target="tex4ht-main"/target=_self/g;
# print $menu;
my @span= $root->children( 'span');

my @chaplist=();;
my @menu=();
my @menulist=();
my $text;
foreach my $span (@span)
{
    $text=$span->sprint();
    $text=~ s/target="tex4ht-main"/target="_self"/g;
    if ($span->att('class') eq "chapterToc"){
	push @chaplist, $text;
	if ($#chaplist  !=0) {push @menulist, [ @menu ]; @menu=()}
    }
    elsif ($span->att('class') eq "likechapterToc")
	{ 
# delete
      }
    else {    push @menu, $text;}
#    print "$span->att('class')\n";
};
push @menulist, [ @menu ];
#print @chaplist;
for my $menuitem (@menulist){
#    print "MENU\n [ @$menuitem ] \n";
}

my @menus;
my $nmenus= $#menulist;

my $home='<span class="chapterToc"><a href="index.xhtml">home</a></span><br />';
my $chapmenu= encode_entities(join("<br />\n",  $home, @chaplist),'^\n\x20-\x25\x27-\x7e');

for my $i (0..$nmenus-1) {
    push @menus, encode_entities(join("<br />\n",  $home, @chaplist[0 .. $i] , @{$menulist[$i]}, @chaplist[$i+1 .. $nmenus] ),'^\n\x20-\x25\x27-\x7e');;}

push @menus, encode_entities( join("<br />\n",  $home, @chaplist[0 .. $nmenus], @{$menulist[$nmenus]} ),'^\n\x20-\x25\x27-\x7e');

print $menus[0];

#system("rm Notes/Notes2.xhtml");

my $now=gmtime();

my @list=qx'ls Notes/Notesse*ml';
my $f;
 $t= XML::Twig->new(twig_roots => { title => 1, body => 1});
foreach $f (@list) {
    print "now: $f\n";
# now extract menu, and apply template; 
#Notes2: menu
#Notes3: start page
#Notesch...: other pages
#extract body from menu
# extract title and body from any other page
# wrap body in <div class="content">
# voila!use XML::Parser;
    $t->parsefile($f);
    $root= $t->root;
    my $title= $root->first_child( 'title'); # get the title
    my $titext=$title->inner_xml();
    my $body= $root->first_child( 'body'); # get the title
    $body->set_tag( 'div');
    $body->set_att( 'id','center');
#    my $content=Encode::decode('iso-8859-1',$body->sprint);
    my $content=encode_entities($body->sprint,'^\n\x20-\x25\x27-\x7e');

    $content =~ /\"titlemark\">(\d)/;
    my $sec=$1;
    $content=~ s/&amp;lt/&lt/g;
    $content=~ s/&amp;gt/&gt/g;
    open(IN,"<template");
    open(OUT,">$f");
    $^I = '';
    while ( <IN> ) {
	s|%title%|$titext|;
	s|%body%|$content|;
	s|%menu%|<div class="menu">$menus[$sec-1]</div>|;
	s|%date%|$now|;
	print OUT $_;
    }
    close(IN);    
    close(OUT);    
}

@list=qx'ls Notes/Notesch*ml Notes/Notes3.xhtml';
foreach $f (@list) {
    print "now: $f\n";
# now extract menu, and apply template; 
#Notes2: menu
#Notes3: start page
#Notesch...: other pages
#extract body from menu
# extract title and body from any other page
# wrap body in <div class="content">
# voila!use XML::Parser;
    $t->parsefile($f);
    $root= $t->root;
    my $title= $root->first_child( 'title'); # get the title
    my $titext=$title->inner_xml();
    my $body= $root->first_child( 'body'); # get the title
    $body->set_tag( 'div');
    $body->set_att( 'id','center');
#    my $content=Encode::decode('iso-8859-1',$body->sprint);
    my $content=encode_entities($body->sprint,'^\n\x20-\x25\x27-\x7e');

    $content =~ /\"titlemark\">(\d)/;
    my $sec=$1;
    $content=~ s/&amp;lt/&lt/g;
    $content=~ s/&amp;gt/&gt/g;
    open(IN,"<template");
    open(OUT,">$f");
    $^I = '';
    while ( <IN> ) {
	s|%title%|$titext|;
	s|%body%|$content|;
	s|%menu%|<div class="menu">$chapmenu</div>|;
	s|%date%|$now|;
	print OUT $_;
    }
    close(IN);    
    close(OUT);    
}

system ("mv  Notes/Notes3.xhtml Notes/index.xhtml");
